import { HeartRate } from "@zos/sensor";

export default class HeartRateSensor {
  constructor() {
    this.heartRate = new HeartRate();
  }

  init(callback) {
    console.log("Initializing Heart Rate Sensor");

    try {
      this.heartRate.onCurrentChange(() => {
        const currentValue = this.heartRate.getCurrent();
        console.log("Heart rate updated:", currentValue);

        if (callback) callback(currentValue);
      });
    } catch (error) {
      console.error("Error initializing Heart Rate Sensor:", error);
    }
  }

  getCurrentValue() {
    try {
      const currentValue = this.heartRate.getCurrent();
      console.log("Current heart rate:", currentValue);
      return currentValue || 0;
    } catch (error) {
      console.error("Error fetching current heart rate:", error);
      return 0;
    }
  }
}
