import { Sleep } from "@zos/sensor";
import { LocalStorage } from "@zos/storage";

export default class SleepSensor {
  constructor() {
    this.sleep = new Sleep();
    this.localStorage = new LocalStorage();
  }

  init(callback) {
    console.log("Initializing Sleep Sensor");

    try {
      const sleepInfo = this.sleep.getInfo();
    //   const sleepStages = this.sleep.getStage();
    //   const stageConstants = this.sleep.getStageConstantObj();

      console.log("Sleep Info:", sleepInfo);
    //   console.log("Sleep Stages:", sleepStages);
    //   console.log("Stage Constants:", stageConstants);

    //   // Count occurrences of each stage
    //   const stageCounts = {
    //     awake: 0,
    //     light: 0,
    //     deep: 0,
    //     rem: 0,
    //   };

    //   sleepStages.forEach((stage) => {
    //     switch (stage.model) {
    //       case stageConstants.WAKE_STAGE:
    //         stageCounts.awake += 1;
    //         break;
    //       case stageConstants.LIGHT_STAGE:
    //         stageCounts.light += 1;
    //         break;
    //       case stageConstants.DEEP_STAGE:
    //         stageCounts.deep += 1;
    //         break;
    //       case stageConstants.REM_STAGE:
    //         stageCounts.rem += 1;
    //         break;
    //     }
    //   });

      // Save data to storage
      const sleepData = {
        score: sleepInfo.score || 0,
        // stageCounts,
      };
      this.saveDataToStorage("sleep", sleepData);

      // Execute callback
      if (callback) {
        callback(sleepData);
      }
    } catch (error) {
      console.error("Error initializing Sleep Sensor:", error);
    }
  }

  saveDataToStorage(sensorType, data) {
    const timestamp = new Date().toISOString();
    const sensorData = { ...data, timestamp };

    try {
      this.localStorage.setItem(sensorType, JSON.stringify(sensorData));
      console.log(`Saved ${sensorType} data:`, sensorData);
    } catch (error) {
      console.error(`Failed to save ${sensorType} data:`, error);
    }
  }

  getDataFromStorage() {
    try {
      const sleepData = JSON.parse(this.localStorage.getItem("sleep"));
      console.log("Fetched Sleep Data from storage:", sleepData);
      return sleepData || { score: 0 };
    } catch (error) {
      console.error("Error fetching Sleep data from storage:", error);
      return { score: 0};
    }
  }
}
