import { Stress } from "@zos/sensor";

export default class StressSensor {
  constructor() {
    this.stress = new Stress();
    this.currentValue = null;
  }

  init(callback) {
    console.log("Initializing Stress Sensor");

    try {
      this.stress.onChange(() => {
        const data = this.stress.getCurrent();
        console.log("Stress data:", data);

        if (data && data.value !== undefined) {
          this.currentValue = data.value; 
          console.log("Updated Stress Value:", this.currentValue);

          if (callback) callback(this.currentValue);
        } else {
          console.warn("Stress value is undefined or null.");
        }
      });
      console.log("Stress sensor started successfully.");
    } catch (error) {
      console.error("Error initializing Stress Sensor:", error);
    }
  }

  getCurrentValue() {
    const currentValue = this.stress.getCurrent();
    console.log("current stress value",currentValue.value);
    return currentValue.value || 0;
  }

  stop() {
    try {
      this.stress.stop();
      console.log("Stress sensor stopped successfully.");
    } catch (error) {
      console.error("Error stopping Stress Sensor:", error);
    }
  }
}
